#!/bin/bash


rm *.png *.ps



cp ../elocate.dat .

#Crear formato en HP71
# ifort -o crear_formato2 crear_formato2.f
# ifort -o preparar_varios preparar_varios.f

crear_formato2
cp fases.dat f1
tr '[a-z]' '[A-Z]' < f1 > fases.dat
rm f1


#Crear formato de estaciones.
# ifort -o pasar2 pasar2.f

awk -F\; '{printf"%4s %8.4f %8.4f %4d\n", $1,$2,$3,$5}' ../estaciones2.txt > tempo.dat
cut -c1-4 tempo.dat > t0
cut -c6-9 tempo.dat > t1
cut -c10-14 tempo.dat > t2
cut -c17-18 tempo.dat > t3
cut -c19-23 tempo.dat > t4
cut -c24-28 tempo.dat > t5

paste t0 t1 t2 t3 t4 t5 > tempo1.dat
awk '{print $1,-1.0*$2,$3*60,$4,$5*60,$6*1.0}' tempo1.dat > tempo2.dat
pasar2
rm tempo.dat tempo1.dat t?


#Crea formato de velocidades
awk '{if(NR==1) print $1,$2,$3,$4,$5}' ../VEL.MOD > cr2.vel
awk '{if(NR>3) printf"%5.2f%5.1f\n",$2,$1}' ../VEL.MOD >> cr2.vel


if [ -f varios.dat ]
then
  rm varios.dat 
fi

if [ -f evento.arc ]
then
  rm evento.arc
fi

if [ -f evento.prt ]
then
  rm evento.prt
fi

if [ -f varios.dat ]
then
  rm varios.dat
fi





for i in `seq 1 2 250`
do
  sed s/XXX/$i/g parametros.hyp.in > parametros.hyp
  ./hyp1.3< parametros.hyp > salida.dat
  cat evento.sum >> varios.dat
done
preparar_varios
sort -n -k13 salida_varios.dat | head -n 1 | awk '{print -($6+$7/60),$4+$5/60,$8,$13,$1,$2,$3}' > resultado.dat
cat resultado.dat

xlon=`awk '{printf"%7.3f\n", $1}' resultado.dat`
xlat=`awk '{printf"%7.3f\n", $2}' resultado.dat`
xpro=`awk '{printf"%5.1f\n", $3}' resultado.dat`
xrms=`awk '{printf"%7.3f\n", $4}' resultado.dat`
yyy=`awk '{printf"%8s\n", $5}' resultado.dat | cut -c1-4`
mmm=`awk '{printf"%8s\n", $5}' resultado.dat | cut -c5-6`
ddd=`awk '{printf"%8s\n", $5}' resultado.dat | cut -c7-8`
hhh=`awk '{printf"%4s\n", $6}' resultado.dat | cut -c1-2`
nnn=`awk '{printf"%4s\n", $6}' resultado.dat | cut -c3-4`
sss=`awk '{printf"%4s\n", $7}' resultado.dat | cut -c1-2`

etime="$yyy/$mmm/$ddd $hhh:$nnn:$sss"

echo $xlon $xlat $xpro $xrms $yyy $mmm $ddd $hhh $nnn $sss > resultado_hyp13.dat





# 109.3 km corresponden a 4.1 cm que es 1 grado en este mapa
# 109.3 km corresponden a 1.61 pulgadas

#Mapa en GMT version 5.1

echo -84.054 09.938 > sjs.dat
grep  "IS VNE" evento.prt | awk '{print $1}' > lista.dat
if [ -f estaciones_usadas.dat ]
then
  rm estaciones_usadas.dat
fi
for i in `cat lista.dat`
do
    grep $i estaciones2.txt | awk -F\; '{print $2,$3}' | psxy -R -JM -W1 -St0.1 -Ggreen -O -K >> p.ps
    grep $i estaciones2.txt | awk -F\; '{print $2,$3,$1}' >> estaciones_usadas.dat     
done
echo "-86.6 7.815 11 0 0 1 Estaciones usadas para el c\337lculo:" > info.dat

if [ -f ../mw.dat ]
then
  cp ../mw.dat .
  mw=`head -n 1 mw.dat`
else
  mw="---"
  echo $mw > mw.dat
fi

pf=$xpro
elon=$xlon
elat=$xlat
rms=$xrms
err_lat="---"
err_lon="---"
err_pro="---"
desanjose=`awk '{a=sqrt((x0-$1)*(x0-$1)+(y0-$2)*(y0-$2));printf"%6.1f\n", a*109.3}' x0="$elon" y0="$elat" sjs.dat`
echo $elon $elat > epi.dat


echo "-86.6 7.815 Estaciones usadas para el c\341lculo:" > info1.dat  
echo "-86.6 7.7  Origen (UTC): " >> info1.dat
echo "-86.6 7.6  Magnitud Momento (Mw)=" >> info1.dat
echo "-86.6 7.5  Distancia de San Jos\351(km)= " >> info1.dat
echo "-86.6 7.4  Profundidad (km)= " >> info1.dat
echo "-86.6 7.3  Longitud= " >> info1.dat
echo "-86.6 7.2  Latitud= " >> info1.dat
echo "-86.6 7.1  Error RMS= " >> info1.dat

echo "-85.0 7.6 " $mw  > info2.dat
echo "-85.0 7.5 " $desanjose  >> info2.dat
echo "-85.0 7.4 " $pf "\261" $err_pro >> info2.dat
echo "-85.0 7.3 " $elon  "\261" $err_lon >> info2.dat
echo "-85.0 7.2 " $elat  "\261" $err_lat >> info2.dat
echo "-85.0 7.1 " $rms >> info2.dat

echo "-85.0 7.7 " $etime  > info3.dat

gmt gmtset MAP_FRAME_TYPE PLAIN
gmt gmtset PS_MEDIA letter

gmt psbasemap -R-86.8/-81.8/7.0/11.7 -JM8.0i -B0/0 -P  -K -X0.3i -Y3.0i -V > p.ps
#gmt grdimage ../surf.grd -R -JM -C../fondo.cpt -X0 -Y0 -I../gradients.grd -K  -O >> p.ps


gmt pscoast -R -J -N2/white -K  -Df -B -O  -G100/100/100 -S150/150/150 >> p.ps
for j in /usr/local/gmt/parches/*.txt
do
  gmt psxy -R -J -O -K -B -G100/100/100 $j >> p.ps
done
gmt pscoast -R -J -N1/1.5 -W0.1 -X0 -K -Y0  -Df -B -O  -Lf-83.5/7.5/10.0/100.0+lkm >> p.ps

makecpt -T-2000/5000/100 -Z -Cdem1 > n2.cpt

gmt pscoast -R -J -N1/2,black -K  -Df -B -O -W0.5 >> p.ps

awk '{print $1+0.02,$2-0.01}' estaciones_usadas.dat | gmt psxy -R -JM -W0.1 -St0.1i -G0 -O -K >> p.ps
awk '{print $1,$2}' estaciones_usadas.dat | gmt psxy -R -JM -W0.1 -St0.1i -Ggreen -O -K >> p.ps

gmt psxy -R -JM -W0.5,black -Sc0.1i -Gyellow -O -K epi.dat >> p.ps
gmt psxy -R -JM -W1.4,white -Sc0.2i -O -K epi.dat >> p.ps
gmt psxy -R -JM -W1.2,white -Sc0.3i -O -K epi.dat >> p.ps
gmt psxy -R -JM -W0.8,white -Sc0.4i -O -K epi.dat >> p.ps
gmt psxy -R -JM -W0.6,white -Sc0.5i -O -K epi.dat >> p.ps
gmt psxy -R -JM -W0.2,white -Sc0.6i -O -K epi.dat >> p.ps



awk '{print $1,$2+0.25,"Epicentro"}' epi.dat | gmt pstext -R  -F+f12p,Helvetica-Bold,white+jMC -JM -O -K -TO -Gblack >> p.ps

gmt pstext -R -J -O -F+f12p,Helvetica-Bold,black,+jBR -K -W0.1 -Gwhite -TO <<END>> p.ps
-81.85 7.08 Laboratorio de Ingenier\354a S\354smica (INII-UCR)
END

gmt pstext -R -JM -O -K  -F+f12p,Helvetica-Bold,yellow,+jTR  -G0 -W0.1 -TO <<END>> p.ps
-81.84 11.65 METODO HYPOINVERSE
END


gmt psxy -R -J -W2 -Gwhite -O -K <<END>> p.ps
-86.65 7.92
-84.95 7.92
-84.95 7.05
-86.65 7.05
-86.65 7.92
END
gmt pstext -R -JM -O -K -F+f11p,Helvetica,black,+jBL info1.dat >> p.ps
gmt pstext -R -JM -O -K -F+f11p,Helvetica,black,+jBR info2.dat >> p.ps
gmt pstext -R -JM -O -K -F+f11p,Helvetica-Bold,black,+jBR info3.dat >> p.ps

gmt psxy -R -JM -W0.1 -St0.113i -Ggreen -O -K <<END>> p.ps
-85.05 7.85
END

gmt psxy -R -JM -O <<END>>p.ps
END

convert p.ps -crop 590x560+15+25 epicentro.png

display epicentro.png &






















# 
# echo===========================
# echo Mapa en GMT
# echo===========================
# 
# # 109.3 km corresponden a 4.1 cm que es 1 grado en este mapa
# # 109.3 km corresponden a 1.61 pulgadas
# 
# gmtset        BASEMAP_TYPE PLAIN
# 
# echo -84.054 09.938 > sjs.dat
# psbasemap -R-86.8/-81.8/7.0/11.7 -JM8.0 -B0/0 -P  -K -X0.3 -Y3.0 -V > p.ps
# 
# pscoast -R -JM -N1/5 -N2/220/220/220 -W1 -X0 -K -Y0  -Df -B -O  -Lf-83.5/7.5/10.0/100.0 -G150/150/150 -Slightblue >> p.ps
# 
# grep  "IS VNE" evento.prt | awk '{print $1}' > lista.dat
# 
# if [ -f estaciones_usadas.dat ]
# then
#   rm estaciones_usadas.dat
# fi
# for i in `cat lista.dat`
# do
#     grep $i estaciones2.txt | awk -F\; '{print $2,$3}' | psxy -R -JM -W1 -St0.1 -Ggreen -O -K >> p.ps
#     grep $i estaciones2.txt | awk -F\; '{print $2,$3,$1}' >> estaciones_usadas.dat     
# done
# echo "-86.6 7.815 11 0 0 1 Estaciones usadas para el c\337lculo:" > info.dat
# 
# if [ -f ../mw.dat ]
# then
#   cp ../mw.dat .
#   mw=`head -n 1 mw.dat`
# else
#   mw="---"
#   echo $mw > mw.dat
# fi
# 
# pf=$xpro
# elon=$xlon
# elat=$xlat
# rms=$xrms
# err_lat="---"
# err_lon="---"
# err_pro="---"
# de=`awk '{a=sqrt((x0-$1)*(x0-$1)+(y0-$2)*(y0-$2));printf"%6.1f\n", a*109.3}' x0="$elon" y0="$elat" sjs.dat`
# 
# echo $elon $elat > epi.dat
# 
# echo "-86.6 7.7 11 0 0 1 Origen (UTC): " >> info.dat
# echo "-85.0 7.7 11 0 1 3 " $etime  >> info.dat
# 
# echo "-86.6 7.6 11 0 0 1 Magnitud Momento (Mw)=" >> info.dat
# echo "-85.0 7.6 11 0 0 3 " $mw  >> info.dat
# 
# echo "-86.6 7.5 11 0 0 1 Distancia de San Jos\345 (km)= " >> info.dat
# echo "-85.0 7.5 11 0 0 3 " $de  >> info.dat
# 
# echo "-86.6 7.4 11 0 0 1 Profundidad (km)= " >> info.dat
# echo "-85.0 7.4 11 0 0 3 " $pf "\234" $err_pro >> info.dat
# 
# echo "-86.6 7.3 11 0 0 1 Longitud= " >> info.dat
# echo "-85.0 7.3 11 0 0 3 " $elon  "\234" $err_lon >> info.dat
# 
# echo "-86.6 7.2 11 0 0 1 Latitud= " >> info.dat
# echo "-85.0 7.2 11 0 0 3 " $elat  "\234" $err_lat >> info.dat
# 
# echo "-86.6 7.1 11 0 0 1 Error RMS= " >> info.dat
# echo "-85.0 7.1 11 0 0 3 " $rms >> info.dat
# 
# 
# 
# psxy -R -JM -W1 -S+0.35 -O -K epi.dat >> p.ps
# psxy -R -JM -W1 -Sc0.1 -Gyellow -O -K epi.dat >> p.ps
# psxy -R -JM -W1 -Sc0.16 -O -K epi.dat >> p.ps
# psxy -R -JM -W1 -Sc0.22 -O -K epi.dat >> p.ps
# psxy -R -JM -W1 -Sc0.28 -O -K epi.dat >> p.ps
# awk '{print $1,$2+0.12, 10, 0, 0, 2, "Epicentro"}' epi.dat | pstext -R -JM -O -K >> p.ps
# 
# pstext -R -JM -O -K -G0 -W255/255/255O <<END>> p.ps
# -81.85 7.08 12 0 1 3 Laboratorio de Ingenier\354a S\354smica (INII-UCR)
# END
# 
# pstext -R -JM -O -K -Ggreen -W0/0/0O/255/255/255o <<END>> p.ps
# -81.83 11.58 12 0 1 3 EPICENTRO y MAGNITUD
# END
# 
# psxy -R -JM -W1 -G255 -O -K <<END>> p.ps
# -86.65 7.92
# -84.95 7.92
# -84.95 7.05
# -86.65 7.05
# -86.65 7.92
# END
# 
# 
# pstext -R -JM -O -K info.dat >> p.ps
# 
# psxy -R -JM -W1 -St0.113 -Ggreen -O -K <<END>> p.ps
# -85.05 7.85
# END
# 
# pstext -R -JM -O -K -Gred -W250/250/25O/0/0/0o <<END>> p.ps
# -86.6 8.0 14 0 1 1 M\345todo: Hypoinverse
# END
# 
# 
# psxy -R -JM -O <<END>>p.ps
# END
# 
# convert p.ps -crop 590x560+15+25 epicentro.png
# 
# display epicentro.png &

rm elocate.dat parametros.hyp tempo2.dat salida.dat sjs.dat
